/*****************************************************************************
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
/*                                                                           */
/*                                   #                                       */
/*                                   #                                       */
/*                                  ###                                      */
/*                                  ###                                      */
/*                                 #####                                     */
/*                                 #####                                     */
/*                                #######                                    */
/*                                #######                                    */
/*                   #################################                       */
/*                       #########################                           */
/*                           #################                               */
/*                  [[[[The Working Class Unlimited]]]                       */
/*                             #############                                 */
/*                             #############                                 */
/*                            ######   ######                                */
/*                            ###         ####                               */
/*                           ##              ##                              */
/*                          #                  #                             */
/*                                                                           */
/*                 (C) The Working Class Unlimited 1993.                     */

/**
 **
 **
 **                X p g p  -  P r i m i t i v e s   v2.27
 **
 **
 **
 **                                                   Milanovic Ljubomir, 1995.
 **/
#include "XpgpP.h"

						/* Current Output */
struct __XpgpOutput {
    int N;					/* ordinal number of dev. */
    union __Xpgp_OutputDevice OutDev;		/* output device */
    int ODtype;					/* device type */
    struct __XpgpOutput *nextOut;		/* pointer to next device */
} *XpgpOutput=NULL;

struct __XpgpOutput        *CurOut;		/* curent oputput */


enum __XpgpFunctions {
  __XpgpFnCloseDevice=0, __XpgpFnSetFocus, __XpgpFnGetMouseStatus,
  __XpgpFnGetMousePressEvent,
  __XpgpFnInk, __XpgpFnPen, __XpgpFnSetBackground,
  __XpgpFnResetPalette, __XpgpFnClearPalette,
  __XpgpFnSetLineWidth, __XpgpFnSetDash, __XpgpFnSetFontSize,
  __XpgpFnClear, __XpgpFnMove, __XpgpFnMoveR,

  __XpgpFnPlot, __XpgpFnPlotR,
  __XpgpFnLine, __XpgpFnLineR, __XpgpFnLineTo,
  __XpgpFnArc, __XpgpFnFilledArc, __XpgpFnCircle, __XpgpFnFilledCircle, 
  __XpgpFnEllipse, __XpgpFnFilledEllipse,
  __XpgpFnRectangle, __XpgpFnRectangleS,
  __XpgpFnFilledRectangle, __XpgpFnFilledRectangleS,
  __XpgpFnTriangle, __XpgpFnFilledTriangle,
  __XpgpFnDrawString, 

  __XpgpFnfShow,
  __XpgpFnfPlot, __XpgpFnfPlotR,
  __XpgpFnfLine, __XpgpFnfLineR, __XpgpFnfLineTo,
  __XpgpFnfArc, __XpgpFnfFilledArc, __XpgpFnfCircle, __XpgpFnfFilledCircle, 
  __XpgpFnfEllipse, __XpgpFnfFilledEllipse,
  __XpgpFnfRectangle, __XpgpFnfRectangleS,
  __XpgpFnfFilledRectangle, __XpgpFnfFilledRectangleS,
  __XpgpFnfTriangle, __XpgpFnfFilledTriangle,
  __XpgpFnfDrawString, 
  
  __XpgpFnSetQP,
  __XpgpFnPlotQP, __XpgpFnfPlotQP,
  __XpgpFnPutImage, __XpgpFnPutBitmap
};
  

static int(*Xpgp_Fn[128][3])() = { {NULL, NULL} };

int __Xpgp_Init_Global()
{
  Xpgp_Fn[__XpgpFnArc][0] = (int (*)())__XpgpX_Arc;
  Xpgp_Fn[__XpgpFnArc][1] = (int (*)())__XpgpPS_Arc;
  Xpgp_Fn[__XpgpFnArc][2] = (int (*)())__XpgpBMP_Arc;

  Xpgp_Fn[__XpgpFnCircle][0] = (int (*)())__XpgpX_Circle;
  Xpgp_Fn[__XpgpFnCircle][1] = (int (*)())__XpgpPS_Circle;
  Xpgp_Fn[__XpgpFnCircle][2] = (int (*)())__XpgpBMP_Circle;

  Xpgp_Fn[__XpgpFnClear][0] = (int (*)())__XpgpX_Clear;
  Xpgp_Fn[__XpgpFnClear][1] = (int (*)())__XpgpPS_Clear;
  Xpgp_Fn[__XpgpFnClear][2] = (int (*)())__XpgpBMP_Clear;

  Xpgp_Fn[__XpgpFnClearPalette][0] = (int (*)())__XpgpX_ClearPalette;
  Xpgp_Fn[__XpgpFnClearPalette][1] = (int (*)())__XpgpPS_ClearPalette;
  Xpgp_Fn[__XpgpFnClearPalette][2] = (int (*)())__XpgpBMP_ClearPalette;

  Xpgp_Fn[__XpgpFnCloseDevice][0] = (int (*)())__XpgpX_CloseX;
  Xpgp_Fn[__XpgpFnCloseDevice][1] = (int (*)())__XpgpPS_ClosePS;
  Xpgp_Fn[__XpgpFnCloseDevice][2] = (int (*)())__XpgpBMP_CloseBMP;

  Xpgp_Fn[__XpgpFnDrawString][0] = (int (*)())__XpgpX_DrawString;
  Xpgp_Fn[__XpgpFnDrawString][1] = (int (*)())__XpgpPS_DrawString;
  Xpgp_Fn[__XpgpFnDrawString][2] = (int (*)())__XpgpBMP_DrawString;

  Xpgp_Fn[__XpgpFnEllipse][0] = (int (*)())__XpgpX_Ellipse;
  Xpgp_Fn[__XpgpFnEllipse][1] = (int (*)())__XpgpPS_Ellipse;
  Xpgp_Fn[__XpgpFnEllipse][2] = (int (*)())__XpgpBMP_Ellipse;

  Xpgp_Fn[__XpgpFnFilledArc][0] = (int (*)())__XpgpX_FilledArc;
  Xpgp_Fn[__XpgpFnFilledArc][1] = (int (*)())__XpgpPS_FilledArc;
  Xpgp_Fn[__XpgpFnFilledArc][2] = (int (*)())__XpgpBMP_FilledArc;

  Xpgp_Fn[__XpgpFnFilledCircle][0] = (int (*)())__XpgpX_FilledCircle;
  Xpgp_Fn[__XpgpFnFilledCircle][1] = (int (*)())__XpgpPS_FilledCircle;
  Xpgp_Fn[__XpgpFnFilledCircle][2] = (int (*)())__XpgpBMP_FilledCircle;

  Xpgp_Fn[__XpgpFnFilledEllipse][0] = (int (*)())__XpgpX_FilledEllipse;
  Xpgp_Fn[__XpgpFnFilledEllipse][1] = (int (*)())__XpgpPS_FilledEllipse;
  Xpgp_Fn[__XpgpFnFilledEllipse][2] = (int (*)())__XpgpBMP_FilledEllipse;

  Xpgp_Fn[__XpgpFnFilledRectangle][0] = (int (*)())__XpgpX_FilledRectangle;
  Xpgp_Fn[__XpgpFnFilledRectangle][1] = (int (*)())__XpgpPS_FilledRectangle;
  Xpgp_Fn[__XpgpFnFilledRectangle][2] = (int (*)())__XpgpBMP_FilledRectangle;

  Xpgp_Fn[__XpgpFnFilledRectangleS][0] = (int (*)())__XpgpX_FilledRectangleS;
  Xpgp_Fn[__XpgpFnFilledRectangleS][1] = (int (*)())__XpgpPS_FilledRectangleS;
  Xpgp_Fn[__XpgpFnFilledRectangleS][2] = (int (*)())__XpgpBMP_FilledRectangleS;

  Xpgp_Fn[__XpgpFnFilledTriangle][0] = (int(*)())__XpgpX_FilledTriangle;
  Xpgp_Fn[__XpgpFnFilledTriangle][1] = (int (*)())__XpgpPS_FilledTriangle;
  Xpgp_Fn[__XpgpFnFilledTriangle][2] = (int (*)())__XpgpBMP_FilledTriangle;
  
  Xpgp_Fn[__XpgpFnGetMouseStatus][0] = (int(*)())__XpgpX_GetMouseStatus;
  Xpgp_Fn[__XpgpFnGetMouseStatus][1] = (int (*)())__XpgpPS_GetMouseStatus;
  Xpgp_Fn[__XpgpFnGetMouseStatus][2] = (int (*)())__XpgpBMP_GetMouseStatus;

  Xpgp_Fn[__XpgpFnGetMousePressEvent][0] = (int (*)())__XpgpX_GetMousePressEvent;
  Xpgp_Fn[__XpgpFnGetMousePressEvent][1] = (int (*)())__XpgpPS_GetMousePressEvent;
  Xpgp_Fn[__XpgpFnGetMousePressEvent][2] = (int (*)())__XpgpBMP_GetMousePressEvent;

  Xpgp_Fn[__XpgpFnSetFocus][0] = (int (*)())__XpgpX_SetFocus;
  Xpgp_Fn[__XpgpFnSetFocus][1] = (int (*)())__XpgpPS_SetFocus;
  Xpgp_Fn[__XpgpFnSetFocus][2] = (int (*)())__XpgpBMP_SetFocus;

  Xpgp_Fn[__XpgpFnInk][0] = (int (*)())__XpgpX_Ink;
  Xpgp_Fn[__XpgpFnInk][1] = (int (*)())__XpgpPS_Ink;
  Xpgp_Fn[__XpgpFnInk][2] = (int (*)())__XpgpBMP_Ink;

  Xpgp_Fn[__XpgpFnLine][0] = (int (*)())__XpgpX_Line;
  Xpgp_Fn[__XpgpFnLine][1] = (int (*)())__XpgpPS_Line;
  Xpgp_Fn[__XpgpFnLine][2] = (int (*)())__XpgpBMP_Line;

  Xpgp_Fn[__XpgpFnLineR][0] = (int (*)())__XpgpX_LineR;
  Xpgp_Fn[__XpgpFnLineR][1] = (int (*)())__XpgpPS_LineR;
  Xpgp_Fn[__XpgpFnLineR][2] = (int (*)())__XpgpBMP_LineR;

  Xpgp_Fn[__XpgpFnLineTo][0] = (int (*)())__XpgpX_LineTo;
  Xpgp_Fn[__XpgpFnLineTo][1] = (int (*)())__XpgpPS_LineTo;
  Xpgp_Fn[__XpgpFnLineTo][2] = (int (*)())__XpgpBMP_LineTo;

  Xpgp_Fn[__XpgpFnMove][0] = (int (*)())__XpgpX_Move;
  Xpgp_Fn[__XpgpFnMove][1] = (int (*)())__XpgpPS_Move;
  Xpgp_Fn[__XpgpFnMove][2] = (int (*)())__XpgpBMP_Move;

  Xpgp_Fn[__XpgpFnMoveR][0] = (int (*)())__XpgpX_MoveR;
  Xpgp_Fn[__XpgpFnMoveR][1] = (int (*)())__XpgpPS_MoveR;
  Xpgp_Fn[__XpgpFnMoveR][2] = (int (*)())__XpgpBMP_MoveR;

  Xpgp_Fn[__XpgpFnPen][0] = (int (*)())__XpgpX_Pen;
  Xpgp_Fn[__XpgpFnPen][1] = (int (*)())__XpgpPS_Pen;
  Xpgp_Fn[__XpgpFnPen][2] = (int (*)())__XpgpBMP_Pen;
  
  Xpgp_Fn[__XpgpFnPlot][0] = (int (*)())__XpgpX_Plot;
  Xpgp_Fn[__XpgpFnPlot][1] = (int (*)())__XpgpPS_Plot;
  Xpgp_Fn[__XpgpFnPlot][2] = (int (*)())__XpgpBMP_Plot;

  Xpgp_Fn[__XpgpFnPlotQP][0] = (int (*)())__XpgpX_PlotQP;
  Xpgp_Fn[__XpgpFnPlotQP][1] = (int (*)())__XpgpPS_PlotQP;
  Xpgp_Fn[__XpgpFnPlotQP][2] = (int (*)())__XpgpBMP_PlotQP;

  Xpgp_Fn[__XpgpFnPlotR][0] = (int (*)())__XpgpX_PlotR;
  Xpgp_Fn[__XpgpFnPlotR][1] = (int (*)())__XpgpPS_PlotR;
  Xpgp_Fn[__XpgpFnPlotR][2] = (int (*)())__XpgpBMP_PlotR;

  Xpgp_Fn[__XpgpFnRectangle][0] = (int (*)())__XpgpX_Rectangle;
  Xpgp_Fn[__XpgpFnRectangle][1] = (int (*)())__XpgpPS_Rectangle;
  Xpgp_Fn[__XpgpFnRectangle][2] = (int (*)())__XpgpBMP_Rectangle;

  Xpgp_Fn[__XpgpFnRectangleS][0] = (int (*)())__XpgpX_RectangleS;
  Xpgp_Fn[__XpgpFnRectangleS][1] = (int (*)())__XpgpPS_RectangleS;
  Xpgp_Fn[__XpgpFnRectangleS][2] = (int (*)())__XpgpBMP_RectangleS;

  Xpgp_Fn[__XpgpFnResetPalette][0] = (int (*)())__XpgpX_ResetPalette;
  Xpgp_Fn[__XpgpFnResetPalette][1] = (int (*)())__XpgpPS_ResetPalette;
  Xpgp_Fn[__XpgpFnResetPalette][2] = (int (*)())__XpgpBMP_ResetPalette;

  Xpgp_Fn[__XpgpFnSetBackground][0] = (int (*)())__XpgpX_SetBackground;
  Xpgp_Fn[__XpgpFnSetBackground][1] = (int (*)())__XpgpPS_SetBackground;
  Xpgp_Fn[__XpgpFnSetBackground][2] = (int (*)())__XpgpBMP_SetBackground;

  Xpgp_Fn[__XpgpFnSetDash][0] = (int (*)())__XpgpX_SetDash;
  Xpgp_Fn[__XpgpFnSetDash][1] = (int (*)())__XpgpPS_SetDash;
  Xpgp_Fn[__XpgpFnSetDash][2] = (int (*)())__XpgpBMP_SetDash;

  Xpgp_Fn[__XpgpFnSetFontSize][0] = (int (*)())__XpgpX_SetFontSize;
  Xpgp_Fn[__XpgpFnSetFontSize][1] = (int (*)())__XpgpPS_SetFontSize;
  Xpgp_Fn[__XpgpFnSetFontSize][2] = (int (*)())__XpgpBMP_SetFontSize;

  Xpgp_Fn[__XpgpFnSetLineWidth][0] = (int (*)())__XpgpX_SetLineWidth;
  Xpgp_Fn[__XpgpFnSetLineWidth][1] = (int (*)())__XpgpPS_SetLineWidth;
  Xpgp_Fn[__XpgpFnSetLineWidth][2] = (int (*)())__XpgpBMP_SetLineWidth;
  
  Xpgp_Fn[__XpgpFnSetQP][0] = (int (*)())__XpgpX_SetQP;
  Xpgp_Fn[__XpgpFnSetQP][1] = (int (*)())__XpgpPS_SetQP;
  Xpgp_Fn[__XpgpFnSetQP][2] = (int (*)())__XpgpBMP_SetQP;

  Xpgp_Fn[__XpgpFnTriangle][0] = (int (*)())__XpgpX_Triangle;
  Xpgp_Fn[__XpgpFnTriangle][1] = (int (*)())__XpgpPS_Triangle;
  Xpgp_Fn[__XpgpFnTriangle][2] = (int (*)())__XpgpBMP_Triangle;

  Xpgp_Fn[__XpgpFnfArc][0] = (int (*)())__XpgpX_fArc;
  Xpgp_Fn[__XpgpFnfArc][1] = (int (*)())__XpgpPS_Arc;
  Xpgp_Fn[__XpgpFnfArc][2] = (int (*)())__XpgpBMP_Arc;

  Xpgp_Fn[__XpgpFnfCircle][0] = (int (*)())__XpgpX_fCircle;
  Xpgp_Fn[__XpgpFnfCircle][1] = (int (*)())__XpgpPS_Circle;
  Xpgp_Fn[__XpgpFnfCircle][2] = (int (*)())__XpgpBMP_Circle;

  Xpgp_Fn[__XpgpFnfDrawString][0] = (int (*)())__XpgpX_fDrawString;
  Xpgp_Fn[__XpgpFnfDrawString][1] = (int (*)())__XpgpPS_DrawString;
  Xpgp_Fn[__XpgpFnfDrawString][2] = (int (*)())__XpgpBMP_DrawString;

  Xpgp_Fn[__XpgpFnfEllipse][0] = (int (*)())__XpgpX_fEllipse;
  Xpgp_Fn[__XpgpFnfEllipse][1] = (int (*)())__XpgpPS_Ellipse;
  Xpgp_Fn[__XpgpFnfEllipse][2] = (int (*)())__XpgpBMP_Ellipse;

  Xpgp_Fn[__XpgpFnfFilledArc][0] = (int (*)())__XpgpX_fFilledArc;
  Xpgp_Fn[__XpgpFnfFilledArc][1] = (int (*)())__XpgpPS_FilledArc;
  Xpgp_Fn[__XpgpFnfFilledArc][2] = (int (*)())__XpgpBMP_FilledArc;

  Xpgp_Fn[__XpgpFnfFilledCircle][0] = (int (*)())__XpgpX_fFilledCircle;
  Xpgp_Fn[__XpgpFnfFilledCircle][1] = (int (*)())__XpgpPS_FilledCircle;
  Xpgp_Fn[__XpgpFnfFilledCircle][2] = (int (*)())__XpgpBMP_FilledCircle;

  Xpgp_Fn[__XpgpFnfFilledEllipse][0] = (int(*)())__XpgpX_fFilledEllipse;
  Xpgp_Fn[__XpgpFnfFilledEllipse][1] = (int (*)())__XpgpPS_FilledEllipse;
  Xpgp_Fn[__XpgpFnfFilledEllipse][2] = (int (*)())__XpgpBMP_FilledEllipse;
 
  Xpgp_Fn[__XpgpFnfFilledRectangle][0] = (int(*)())__XpgpX_fFilledRectangle;
  Xpgp_Fn[__XpgpFnfFilledRectangle][1] = (int (*)())__XpgpPS_FilledRectangle;
  Xpgp_Fn[__XpgpFnfFilledRectangle][2] = (int (*)())__XpgpBMP_FilledRectangle;

  Xpgp_Fn[__XpgpFnfFilledRectangleS][0] = (int(*)())__XpgpX_fFilledRectangleS;
  Xpgp_Fn[__XpgpFnfFilledRectangleS][1] = (int (*)())__XpgpPS_FilledRectangleS;
  Xpgp_Fn[__XpgpFnfFilledRectangleS][2] = (int (*)())__XpgpBMP_FilledRectangleS;

  Xpgp_Fn[__XpgpFnfFilledTriangle][0] = (int(*)())__XpgpX_fFilledTriangle;
  Xpgp_Fn[__XpgpFnfFilledTriangle][1] = (int (*)())__XpgpPS_FilledTriangle;
  Xpgp_Fn[__XpgpFnfFilledTriangle][2] = (int (*)())__XpgpBMP_FilledTriangle;

  Xpgp_Fn[__XpgpFnfLine][0] = (int (*)())__XpgpX_fLine;
  Xpgp_Fn[__XpgpFnfLine][1] = (int (*)())__XpgpPS_Line;
  Xpgp_Fn[__XpgpFnfLine][2] = (int (*)())__XpgpBMP_Line;

  Xpgp_Fn[__XpgpFnfLineR][0] = (int (*)())__XpgpX_fLineR;
  Xpgp_Fn[__XpgpFnfLineR][1] = (int (*)())__XpgpPS_LineR;
  Xpgp_Fn[__XpgpFnfLineR][2] = (int (*)())__XpgpBMP_LineR;

  Xpgp_Fn[__XpgpFnfLineTo][0] = (int (*)())__XpgpX_fLineTo;
  Xpgp_Fn[__XpgpFnfLineTo][1] = (int (*)())__XpgpPS_LineTo;
  Xpgp_Fn[__XpgpFnfLineTo][2] = (int (*)())__XpgpBMP_LineTo;

  Xpgp_Fn[__XpgpFnfPlot][0] = (int (*)())__XpgpX_fPlot;
  Xpgp_Fn[__XpgpFnfPlot][1] = (int (*)())__XpgpPS_Plot;
  Xpgp_Fn[__XpgpFnfPlot][2] = (int (*)())__XpgpBMP_Plot;

  Xpgp_Fn[__XpgpFnfPlotQP][0] = (int (*)())__XpgpX_fPlotQP;
  Xpgp_Fn[__XpgpFnfPlotQP][1] = (int (*)())__XpgpPS_PlotQP;
  Xpgp_Fn[__XpgpFnfPlotQP][2] = (int (*)())__XpgpBMP_PlotQP;

  Xpgp_Fn[__XpgpFnfPlotR][0] = (int (*)())__XpgpX_fPlotR;
  Xpgp_Fn[__XpgpFnfPlotR][1] = (int (*)())__XpgpPS_PlotR;
  Xpgp_Fn[__XpgpFnfPlotR][2] = (int (*)())__XpgpBMP_PlotR;

  Xpgp_Fn[__XpgpFnfRectangle][0] = (int (*)())__XpgpX_fRectangle;
  Xpgp_Fn[__XpgpFnfRectangle][1] = (int (*)())__XpgpPS_Rectangle;
  Xpgp_Fn[__XpgpFnfRectangle][2] = (int (*)())__XpgpBMP_Rectangle;

  Xpgp_Fn[__XpgpFnfRectangleS][0] = (int (*)())__XpgpX_fRectangleS;
  Xpgp_Fn[__XpgpFnfRectangleS][1] = (int (*)())__XpgpPS_RectangleS;
  Xpgp_Fn[__XpgpFnfRectangleS][2] = (int (*)())__XpgpBMP_RectangleS;

  Xpgp_Fn[__XpgpFnfTriangle][0] = (int (*)())__XpgpX_fTriangle;
  Xpgp_Fn[__XpgpFnfTriangle][1] = (int (*)())__XpgpPS_Triangle;
  Xpgp_Fn[__XpgpFnfTriangle][2] = (int (*)())__XpgpBMP_Triangle;

  Xpgp_Fn[__XpgpFnfShow][0] = (int (*)())__XpgpX_fShow;
  Xpgp_Fn[__XpgpFnfShow][1] = (int (*)())__XpgpPS_fShow;
  Xpgp_Fn[__XpgpFnfShow][2] = (int (*)())__XpgpBMP_fShow;

  Xpgp_Fn[__XpgpFnPutImage][0] = (int (*)())__XpgpX_PutImage;
  Xpgp_Fn[__XpgpFnPutImage][1] = (int (*)())__XpgpPS_PutImage;
  Xpgp_Fn[__XpgpFnPutImage][2] = (int (*)())__XpgpBMP_PutImage;

  Xpgp_Fn[__XpgpFnPutBitmap][0] = (int (*)())__XpgpX_PutBitmap;
  Xpgp_Fn[__XpgpFnPutBitmap][1] = (int (*)())__XpgpPS_PutBitmap;
  Xpgp_Fn[__XpgpFnPutBitmap][2] = (int (*)())__XpgpBMP_PutBitmap;

  return 0;
}


/*
 *
 *   Initialize X
 *
 */
int OpenX(int width, int height)
{
 int lastOD= -1;
 struct __XpgpOutput **term;

 if(Xpgp_Fn[0][0]==NULL)	/* init global Xpgp variable */
   __Xpgp_Init_Global();
    
 for(term = &XpgpOutput;*term!=NULL;term = &(*term)->nextOut)
     lastOD=(*term)->N; 
 
 if((*term=(void *)malloc(sizeof(struct __XpgpOutput)))==NULL) {
   fputs("Xpgp: not enough memory\n",stderr);
   return -1;
 }
 CurOut = *term;
 CurOut->N=lastOD+1;
 CurOut->nextOut=NULL;
 CurOut->ODtype=Xpgp_X;

 CurOD = &CurOut->OutDev;
 CurODtype=Xpgp_X;
 
 CurOD->X.QPd=5;				/* init parameters */
 CurOD->X.QPshape=0;
 CurOD->X.inks=NULL;
 CurOD->X.NofInks=0;
 CurOD->X.gcur.x=0;
 CurOD->X.gcur.y=0;
 
 if(__XpgpX_InitX11(width,height)==0)           /* init X11 */
   return CurOut->N;
 else
   return -1;
}


/*
 *
 *   Initialize X (Extended)
 *                                   1994, Horst Wagner
 *
 */
int OpenXX(int width, int height, int xposition, int yposition,
           char* windowname, char* iconname, char* iconfile,
           char* icondata)
{
 int lastOD= -1;
 struct __XpgpOutput **term;
    
 if(Xpgp_Fn[0][0]==NULL)	/* init global Xpgp variable */
   __Xpgp_Init_Global();

 for(term = &XpgpOutput;*term!=NULL;term = &(*term)->nextOut)
     lastOD=(*term)->N;
 
 if((*term=(void *)malloc(sizeof(struct __XpgpOutput)))==NULL) {
   fputs("Xpgp: not enough memory\n",stderr);
   return -1;
 }
 CurOut = *term;
 CurOut->N=lastOD+1;
 CurOut->nextOut=NULL;
 CurOut->ODtype=Xpgp_X;

 CurOD = &CurOut->OutDev;
 CurODtype=Xpgp_X;
 
 CurOD->X.QPd=5;				/* init parameters */
 CurOD->X.QPshape=0;
 CurOD->X.inks=NULL;
 CurOD->X.NofInks=0;
 CurOD->X.gcur.x=0;
 CurOD->X.gcur.y=0;
 
 if(__XpgpX_InitX11X(width,height,xposition,yposition,
		  windowname,iconname,iconfile,icondata)==0)      /* init X11 */
   return CurOut->N;
 else
   return -1;
}




/*
 *
 *   Initialize PS
 *
 */
int OpenPS(char *file_name,int orientation)
{
 int lastOD= -1;
 struct __XpgpOutput **term;
    
 if(Xpgp_Fn[0][0]==NULL)	/* init global Xpgp variable */
   __Xpgp_Init_Global();

 for(term = &XpgpOutput;*term!=NULL;term = &(*term)->nextOut)
     lastOD=(*term)->N;
 
 if((*term=(void *)malloc(sizeof(struct __XpgpOutput)))==NULL) {
   fputs("Xpgp: not enough memory\n",stderr);
   return -1;
 }
 CurOut = *term;
 CurOut->N=lastOD+1;
 CurOut->nextOut=NULL;
 CurOut->ODtype=Xpgp_PS;

 CurOD = &CurOut->OutDev;   
 CurODtype=Xpgp_PS;
 
 CurOD->PS.orient=orientation;		/* portrait or landscape */ 
 CurOD->PS.QPd=5;		        /* init parameters */
 CurOD->PS.QPshape=0;
 CurOD->PS.inks=NULL;
 CurOD->PS.NofInks=0;
 CurOD->PS.sr_flag=0ul;			/* set subr. flag */
 CurOD->PS.stroke_counter=0;		/* set stroke counter */
 CurOD->PS.gcur.x=0;
 CurOD->PS.gcur.y=0;
 CurOD->PS.pageCounter=0;

 if(__XpgpPS_InitPS(file_name)==0)
   return CurOut->N;
 else
   return -1;
}

/*
 *
 *   Initialize BMP
 *
 */
int OpenBMP(char *file_name, int width, int height)
{
 int lastOD= -1;
 struct __XpgpOutput **term;
    
 if(Xpgp_Fn[0][0]==NULL)	/* init global Xpgp variable */
   __Xpgp_Init_Global();

 for(term = &XpgpOutput;*term!=NULL;term = &(*term)->nextOut)
     lastOD=(*term)->N;
 
 if((*term=(void *)malloc(sizeof(struct __XpgpOutput)))==NULL) {
   fputs("Xpgp: not enough memory\n",stderr);
   return -1;
 }
 CurOut = *term;
 CurOut->N=lastOD+1;
 CurOut->nextOut=NULL;
 CurOut->ODtype=Xpgp_BMP;

 CurOD = &CurOut->OutDev;   
 CurODtype=Xpgp_BMP;

					/* init parameters */
 CurOD->BMP.bmp=NULL;
 CurOD->BMP.QPd=5;
 CurOD->BMP.QPshape=0;
 CurOD->BMP.inks=NULL;
 CurOD->BMP.NofInks=0;
 CurOD->BMP.gcur.x=0;
 CurOD->BMP.gcur.y=0;
 CurOD->BMP.lw=0;

 if(__XpgpBMP_InitBMP(file_name, width, height)==0)
   return CurOut->N;
 else
   return -1;
}


int OutputTo(int n)
{
 struct __XpgpOutput *tmp;

 for(tmp=XpgpOutput;tmp!=NULL && tmp->N!=n;
     tmp=tmp->nextOut)
     ;
 if(tmp!=NULL && tmp->N==n) {
     CurOut=tmp;
     CurOD = &CurOut->OutDev;   
     CurODtype=CurOut->ODtype;
     return 0;
 } else {
     fprintf(stderr,"Xpgp(OutputTo): device '%d' does not exist!\n",n);
     if(XpgpOutput!=NULL) {
	 n=XpgpOutput->N;
	 fprintf(stderr,"Xpgp(OutputTo): using device '%d' instead\n",n);
	 OutputTo(n);
	 return 1;
     } else {
	 fprintf(stderr,"Xpgp(OutputTo): no device left\n");
	 return 2;
     }
 }
}


int CloseDevice(int n)
{
 struct __XpgpOutput *par,*pred=NULL;
    
 for(par = XpgpOutput;par!=NULL && par->N!=n;
     par = par->nextOut)
     pred=par;
 if(par!=NULL) {
     if(pred!=NULL)
	 pred->nextOut=par->nextOut;
     else
	 XpgpOutput=par->nextOut;
				                       /* close & free mem */
     (*Xpgp_Fn[__XpgpFnCloseDevice][par->ODtype])(&par->OutDev); 
     free(par);
     if(XpgpOutput!=NULL)
	 OutputTo(XpgpOutput->N);
#ifdef WARNINGS
     else
	 fprintf(stderr,"Xpgp(CloseDevice): last device closed\n");
#endif
     return 0;
 } else {
     fprintf(stderr,"Xpgp(CloseDevice): device '%d' does not exist!\n",n);
     return 1;
 }
}


int SetFocus(int n)
{
 struct __XpgpOutput *tmp;

 for(tmp=XpgpOutput;tmp!=NULL && tmp->N!=n;          /* find device n */
     tmp=tmp->nextOut)
     ;
 if(tmp!=NULL && tmp->N==n) {
     CurOut=tmp;
     CurOD = &CurOut->OutDev;
     CurODtype=CurOut->ODtype;
     return(*Xpgp_Fn[__XpgpFnSetFocus][CurODtype])(CurOD);
 } else {
   fprintf(stderr,"Xpgp(SetFocus): device '%d' does not exist!\n",n);
   return -1;
 }
}




/*****************************************************************************/
/*****************************************************************************/

int Arc(double x, double y, double r1, double r2, double a1, double a2) {
 return (*Xpgp_Fn[__XpgpFnArc][CurODtype])(x, y, r1, r2, a1, a2);
}

int Circle(double x, double y, double r) {
 return (*Xpgp_Fn[__XpgpFnCircle][CurODtype])(x, y, r);
}

int Clear(void) {
 return (*Xpgp_Fn[__XpgpFnClear][CurODtype])();
}

int ClearPalette(void) {
 return (*Xpgp_Fn[__XpgpFnClearPalette][CurODtype])();
}

int DrawString(double x, double y, char *text) {
 return (*Xpgp_Fn[__XpgpFnDrawString][CurODtype])(x, y, text);
}

int Ellipse(double x, double y, double r1, double r2) {
 return (*Xpgp_Fn[__XpgpFnEllipse][CurODtype])(x, y, r1, r2);
}

int FilledArc(double x, double y, double r1, double r2, double a1, double a2) {
 return (*Xpgp_Fn[__XpgpFnFilledArc][CurODtype])(x, y, r1, r2, a1, a2);
}

int FilledCircle(double x, double y, double r) {
 return (*Xpgp_Fn[__XpgpFnFilledCircle][CurODtype])(x, y, r);
}

int FilledEllipse(double x, double y, double r1, double r2) {
 return (*Xpgp_Fn[__XpgpFnFilledEllipse][CurODtype])(x, y, r1, r2);
}

int FilledRectangle(double x, double y, double width, double height) {
 return (*Xpgp_Fn[__XpgpFnFilledRectangle][CurODtype])(x, y, width, height);
}

int FilledRectangleS(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnFilledRectangleS][CurODtype])(x1, y1, x2, y2);
}

int FilledTriangle(double x1, double y1, double x2, double y2,
		   double x3, double y3) {
 return (*Xpgp_Fn[__XpgpFnFilledTriangle][CurODtype])(x1, y1, x2, y2, x3, y3);
}

int GetMouseStatus(int *x, int *y, unsigned int *status) {
 return (*Xpgp_Fn[__XpgpFnGetMouseStatus][CurODtype])(x, y, status);
}

int GetMousePressEvent(int *x, int *y, unsigned int *status) {
 return (*Xpgp_Fn[__XpgpFnGetMousePressEvent][CurODtype])(x, y, status);
}

int Ink(unsigned short red, unsigned short green, unsigned short blue) {
 return (*Xpgp_Fn[__XpgpFnInk][CurODtype])(red, green, blue);
}

int Line(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnLine][CurODtype])(x1, y1, x2, y2);
}

int LineR(double dx, double dy) {
 return (*Xpgp_Fn[__XpgpFnLineR][CurODtype])(dx, dy);
}

int LineTo(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnLineTo][CurODtype])(x, y);
}

int Move(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnMove][CurODtype])(x, y);
}

int MoveR(double dx, double dy) {
 return (*Xpgp_Fn[__XpgpFnMoveR][CurODtype])(dx, dy);
}

int Pen(int color) {
 return (*Xpgp_Fn[__XpgpFnPen][CurODtype])(color);
}

int Plot(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnPlot][CurODtype])(x, y);
}

int PlotQP(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnPlotQP][CurODtype])(x, y);
}

int PlotR(double dx, double dy) {
 return (*Xpgp_Fn[__XpgpFnPlotR][CurODtype])(dx, dy);
}

int Rectangle(double x, double y, double width, double height) {
 return (*Xpgp_Fn[__XpgpFnRectangle][CurODtype])(x, y, width, height);
}

int RectangleS(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnRectangleS][CurODtype])(x1, y1, x2, y2);
}

int ResetPalette(void) {
 return (*Xpgp_Fn[__XpgpFnResetPalette][CurODtype])();
}

int SetBackground(int color) {
 return (*Xpgp_Fn[__XpgpFnSetBackground][CurODtype])(color);
}

int SetDash(double b1,double w1,double b2,double w2) {
 return (*Xpgp_Fn[__XpgpFnSetDash][CurODtype])(b1,w1,b2,w2);
}

int SetFontSize(double size) {
 return (*Xpgp_Fn[__XpgpFnSetFontSize][CurODtype])(size);
}

int SetLineWidth(double w) {
 return (*Xpgp_Fn[__XpgpFnSetLineWidth][CurODtype])(w);
}

int SetQP(double d, int shape) {
 return (*Xpgp_Fn[__XpgpFnSetQP][CurODtype])(d, shape);
}

int Triangle(double x1, double y1, double x2, double y2,
	     double x3, double y3) {
 return (*Xpgp_Fn[__XpgpFnTriangle][CurODtype])(x1, y1, x2, y2, x3, y3);
}

int fArc(double x, double y, double r1, double r2, double a1, double a2) {
 return (*Xpgp_Fn[__XpgpFnfArc][CurODtype])(x, y, r1, r2, a1, a2);
}

int fCircle(double x, double y, double r) {
 return (*Xpgp_Fn[__XpgpFnfCircle][CurODtype])(x, y, r);
}

int fDrawString(double x, double y, char *text) {
 return (*Xpgp_Fn[__XpgpFnfDrawString][CurODtype])(x, y, text);
}

int fEllipse(double x, double y, double r1, double r2) {
 return (*Xpgp_Fn[__XpgpFnfEllipse][CurODtype])(x, y, r1, r2);
}

int fFilledArc(double x, double y, double r1, double r2, double a1, double a2) {
 return (*Xpgp_Fn[__XpgpFnfFilledArc][CurODtype])(x, y, r1, r2, a1, a2);
}

int fFilledCircle(double x, double y, double r) {
 return (*Xpgp_Fn[__XpgpFnfFilledCircle][CurODtype])(x, y, r);
}

int fFilledEllipse(double x, double y, double r1, double r2) {
 return (*Xpgp_Fn[__XpgpFnfFilledEllipse][CurODtype])(x, y, r1, r2);
}

int fFilledRectangle(double x, double y, double width, double height) {
 return (*Xpgp_Fn[__XpgpFnfFilledRectangle][CurODtype])(x, y, width, height);
}

int fFilledRectangleS(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnfFilledRectangleS][CurODtype])(x1, y1, x2, y2);
}

int fFilledTriangle(double x1, double y1, double x2, double y2,
		    double x3, double y3) {
 return (*Xpgp_Fn[__XpgpFnfFilledTriangle][CurODtype])(x1, y1, x2, y2, x3, y3);
}

int fLine(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnfLine][CurODtype])(x1, y1, x2, y2);
}
 
int fLineR(double dx, double dy) {
 return (*Xpgp_Fn[__XpgpFnfLineR][CurODtype])(dx, dy);
}

int fLineTo(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnfLineTo][CurODtype])(x, y);
}

int fPlot(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnfPlot][CurODtype])(x, y);
}

int fPlotQP(double x, double y) {
 return (*Xpgp_Fn[__XpgpFnfPlotQP][CurODtype])(x, y);
}

int fPlotR(double dx, double dy) {
 return (*Xpgp_Fn[__XpgpFnfPlotR][CurODtype])(dx, dy);
}

int fRectangle(double x, double y, double width, double height) {
 return (*Xpgp_Fn[__XpgpFnfRectangle][CurODtype])(x, y, width, height);
}

int fRectangleS(double x1, double y1, double x2, double y2) {
 return (*Xpgp_Fn[__XpgpFnfRectangleS][CurODtype])(x1, y1, x2, y2);
}

int fShow(void) {
 return (*Xpgp_Fn[__XpgpFnfShow][CurODtype])();
}

int fTriangle(double x1, double y1, double x2, double y2,
	     double x3, double y3) {
 return (*Xpgp_Fn[__XpgpFnTriangle][CurODtype])(x1, y1, x2, y2, x3, y3);
}

int PutImage(double x, double y, unsigned char *data,
            unsigned int width,unsigned int height) {
 return (*Xpgp_Fn[__XpgpFnPutImage][CurODtype])(x, y, data, width, height);
}

int PutBitmap(double x, double y, char *bitmap,
            unsigned int width,unsigned int height,int fg,int bg) {
 return (*Xpgp_Fn[__XpgpFnPutBitmap][CurODtype])(x, y, bitmap, width, height,fg,bg);
}
