/*****************************************************************************
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
/*                                                                           */
/*                                   #                                       */
/*                                   #                                       */
/*                                  ###                                      */
/*                                  ###                                      */
/*                                 #####                                     */
/*                                 #####                                     */
/*                                #######                                    */
/*                                #######                                    */
/*                   #################################                       */
/*                       #########################                           */
/*                           #################                               */
/*                  [[[[The Working Class Unlimited]]]                       */
/*                             #############                                 */
/*                             #############                                 */
/*                            ######   ######                                */
/*                            ###         ####                               */
/*                           ##              ##                              */
/*                          #                  #                             */
/*                                                                           */
/*                 (C) The Working Class Unlimited 1994.                     */

/**
 **
 **
 **              X p g p  -  P r i m i t i v e s (headers v2.27)
 **
 **
 **
 **                                                 Milanovic Ljubomir, 1995.
 **/

#define QPrect 0	/* Quasi Pixel shape */
#define QPcirc 1

#define PORT   0	/* PostScript portrait */
#define LAND   1        /* PostScript landscape */

#define InitGraph(w,h) OpenX(w,h)		/* backward compatibility */

int Arc(double x, double y, double r1, double r2, double a1, double a2); 
int Circle(double x, double y, double r); 
int Clear(void); 
int ClearPalette(void); 
int CloseDevice(int n);
int DrawString(double x, double y, char *text); 
int Ellipse(double x, double y, double r1, double r2); 
int FilledArc(double x, double y, double r1, double r2, double a1, double a2); 
int FilledCircle(double x, double y, double r); 
int FilledEllipse(double x, double y, double r1, double r2); 
int FilledRectangle(double x, double y, double width, double height); 
int FilledRectangleS(double x1, double y1, double x2, double y2); 
int FilledTriangle(double x1, double y1, double x2, double y2,
		   double x3, double y3);
int GetMouseStatus(int *x, int *y, unsigned int *status); 
int GetMousePressEvent(int *x, int *y, unsigned int *status); 
int Ink(unsigned short red, unsigned short green, unsigned short blue); 
int Line(double x1, double y1, double x2, double y2); 
int LineR(double dx, double dy); 
int LineTo(double x, double y); 
int Move(double x, double y); 
int MoveR(double dx, double dy); 
int OpenBMP(char *file_name, int width, int height);
int OpenPS(char *file_name, int orientation);
int OpenX(int width, int height);
int OpenXX(int width, int height, int xposition, int yposition,
           char* windowname, char* iconname, char* iconfile,char *icondata);
int OutputTo(int n);
int Pen(int color); 
int Plot(double x, double y); 
int PlotQP(double x, double y); 
int PlotR(double dx, double dy); 
int Rectangle(double x, double y, double width, double height); 
int RectangleS(double x1, double y1, double x2, double y2); 
int ResetPalette(void); 
int SetBackground(int color); 
int SetDash(double b1, double w1, double b2, double w2); 
int SetFontSize(double size); 
int SetFocus(int n);
int SetLineWidth(double w); 
int SetQP(double d, int shape); 
int Triangle(double x1, double y1, double x2, double y2, double x3, double y3);
int PutImage(double x, double y, unsigned char *data,
                      unsigned int width,unsigned int height);
int PutBitmap(double x, double y, char *bitmap,
                      unsigned int width,unsigned int height,int fg,int bg);
int fArc(double x, double y, double r1, double r2, double a1, double a2); 
int fCircle(double x, double y, double r); 
int fDrawString(double x, double y, char *text); 
int fEllipse(double x, double y, double r1, double r2); 
int fFilledArc(double x, double y,
	       double r1, double r2, double a1, double a2); 
int fFilledCircle(double x, double y, double r); 
int fFilledEllipse(double x, double y, double r1, double r2); 
int fFilledRectangle(double x, double y, double width, double height); 
int fFilledRectangleS(double x1, double y1, double x2, double y2); 
int fFilledTriangle(double x1, double y1, double x2, double y2,
		    double x3, double y3);
int fLine(double x1, double y1, double x2, double y2); 
int fLineR(double dx, double dy); 
int fLineTo(double x, double y); 
int fPlot(double x, double y); 
int fPlotQP(double x, double y); 
int fPlotR(double dx, double dy); 
int fRectangle(double x, double y, double width, double height); 
int fRectangleS(double x1, double y1, double x2, double y2); 
int fShow(void); 
int fTriangle(double x1, double y1, double x2, double y2,
	      double x3, double y3);
