/*****************************************************************************
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
/*                                                                           */
/*                                   #                                       */
/*                                   #                                       */
/*                                  ###                                      */
/*                                  ###                                      */
/*                                 #####                                     */
/*                                 #####                                     */
/*                                #######                                    */
/*                                #######                                    */
/*                   #################################                       */
/*                       #########################                           */
/*                           #################                               */
/*                  [[[[The Working Class Unlimited]]]                       */
/*                             #############                                 */
/*                             #############                                 */
/*                            ######   ######                                */
/*                            ###         ####                               */
/*                           ##              ##                              */
/*                          #                  #                             */
/*                                                                           */
/*                 (C) The Working Class Unlimited 1993.                     */

/**
 **
 **
 **                 X p g p  -  P r i m i t i v e s   v2.27
 **
 **
 **                              X11 - P a r t
 **
 **                                                  Milanovic Ljubomir, 1995.
 **/
#include "XpgpP.h"


     
/*
 *    Init Graph
 *
 */
int __XpgpX_InitX11(int width,int height)
{
 Window root;
 XSetWindowAttributes wattr;
 XEvent event;
 static int offset=0;


 if((CurOD->X.display=XOpenDisplay(NULL))==NULL) { 
     fputs("Xpgp: can not open display\n",stderr);
     return 1;
 }
 root=XDefaultRootWindow(CurOD->X.display);
 CurOD->X.colormap=XDefaultColormap(CurOD->X.display,
				      XDefaultScreen(CurOD->X.display));

 wattr.event_mask=ExposureMask;
 CurOD->X.window=XCreateWindow(CurOD->X.display,root,
				 40+10*offset++,40+10*offset++,width,height,
				 0,CopyFromParent,InputOutput,CopyFromParent,
				 CWEventMask,
				 &wattr);
 CurOD->X.gc=XCreateGC(CurOD->X.display,CurOD->X.window,
			 0lu,NULL);
 XMapRaised(CurOD->X.display,CurOD->X.window);

 __XpgpX_AllocateBasicColors();
 XSetWindowBackground(CurOD->X.display,CurOD->X.window,CurOD->X.inks[0]);
 XClearWindow(CurOD->X.display,CurOD->X.window);
 __XpgpX_Pen(1);
 __XpgpX_Paper(0);
 __XpgpX_SetFontSize(12);
				    /* wait expose event (no back. store) */
 while(!XCheckWindowEvent(CurOD->X.display,CurOD->X.window,
			  ExposureMask,&event))
     ;


 wattr.event_mask=NoEventMask;			/* set NoEventMask */
 wattr.backing_store=Always;			/* set backing store */
 XChangeWindowAttributes(CurOD->X.display,CurOD->X.window,
			 CWEventMask|CWBackingStore,
			 &wattr);

 if(XDoesBackingStore(XDefaultScreenOfDisplay(CurOD->X.display))!=Always)
     fputs("Xpgp: backing store is not available\n",stderr);

 XFlush(CurOD->X.display);
 return 0;
}

/*
 *
 * Extended version of the InitX11
 *                                   1994, Horst Wagner
 *                                   1995, Ljubomir Milanovic
 *                      
 */
int __XpgpX_InitX11X(int width,int height,int xposition,int yposition,
      		     char* windowname,char* iconname,
		     char* iconfile,char* icondata)
{
 Window root;
 XSetWindowAttributes wattr;
 XEvent event;
/* added */
 Pixmap iconPixmap;
 XSizeHints sizehints;
 unsigned int w,h;
 int xhot,yhot,rv;

 if((CurOD->X.display=XOpenDisplay(NULL))==NULL) { 
     fputs("Xpgp: can not open display\n",stderr);
     return 1;
 }
 root=XDefaultRootWindow(CurOD->X.display);
 CurOD->X.colormap=XDefaultColormap(CurOD->X.display,
				      XDefaultScreen(CurOD->X.display));

 wattr.event_mask=ExposureMask;
 CurOD->X.window=XCreateWindow(CurOD->X.display,root,
				 xposition,yposition,width,height,
				 0,CopyFromParent,InputOutput,CopyFromParent,
				 CWEventMask,
				 &wattr);
 /* added */
 if (iconfile != NULL)
   {
   rv=XReadBitmapFile(CurOD->X.display,CurOD->X.window,
		 iconfile, &w,&h,&iconPixmap,&xhot,&yhot);
   switch(rv) {
   case BitmapOpenFailed:
     fputs("Xpgp(OpenXX): bitmap file open failed\n",stderr);
     break;
   case BitmapFileInvalid:
     fputs("Xpgp(OpenXX): bitmap file invalid\n",stderr);
     break;  
   case BitmapNoMemory:
     fputs("Xpgp(OpenXX): not enough memory for bitmap\n",stderr);
     break;
     }
   }
 else
   {
   /* Create pixmap of depth 1 (bitmap) for icon */

   iconPixmap = XCreateBitmapFromData (CurOD->X.display,CurOD->X.window,
   				       icondata,64,64);
   }
  
 sizehints.min_width = width;
 sizehints.max_width = width;
 sizehints.min_height = height;
 sizehints.max_height = height;
 sizehints.flags = PMinSize | PMaxSize;
 XSetStandardProperties(CurOD->X.display,CurOD->X.window,
			windowname,iconname,iconPixmap,
			(char **)NULL,0,&sizehints);

 CurOD->X.gc=XCreateGC(CurOD->X.display,CurOD->X.window,
		       0lu,NULL);
 XMapRaised(CurOD->X.display,CurOD->X.window);
 
 __XpgpX_AllocateBasicColors();
 XSetWindowBackground(CurOD->X.display,CurOD->X.window,CurOD->X.inks[0]);
 XClearWindow(CurOD->X.display,CurOD->X.window);
 __XpgpX_Pen(1);
 __XpgpX_Paper(0);
 __XpgpX_SetFontSize(12);
				    /* wait expose event (no back. store) */
 while(!XCheckWindowEvent(CurOD->X.display,CurOD->X.window,
			  ExposureMask,&event))
     ;


 wattr.event_mask=ButtonPressMask;	/* Get XButtonPressEvent */
 wattr.backing_store=Always;		/* set backing store */
 XChangeWindowAttributes(CurOD->X.display,CurOD->X.window,
			 CWEventMask|CWBackingStore,
			 &wattr);

 if(XDoesBackingStore(XDefaultScreenOfDisplay(CurOD->X.display))!=Always)
     fputs("Xpgp: backing store is not available\n",stderr);

 XFlush(CurOD->X.display);
 return 0;
}



/*
 *
 *    Close current X output
 *
 */
int __XpgpX_CloseX(union __Xpgp_OutputDevice *dev)
{
 XUnmapWindow(dev->X.display,dev->X.window);
 XDestroyWindow(dev->X.display,dev->X.window);
 XFreeGC(dev->X.display,dev->X.gc);
 free((void *)dev->X.inks);
 XFlush(dev->X.display);
 return 0;
}


int __XpgpX_Clear(void)
{
 XClearWindow(CurOD->X.display,CurOD->X.window);
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fShow(void)
{
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_SetFocus(union __Xpgp_OutputDevice *dev)
{
XRaiseWindow(dev->X.display,dev->X.window);
return 0;
}


int __XpgpX_GetMouseStatus(int *x, int *y, unsigned int *status)
{
 Window root,child;
 int root_x,root_y;
 
 return(XQueryPointer(CurOD->X.display,CurOD->X.window,
		      &root,&child,
		      &root_x,&root_y,
		      x,y,status)==True ? 0:1);
}

int __XpgpX_GetMousePressEvent(int *x, int *y, unsigned int *status)
{
 XEvent event;

 if(XCheckWindowEvent(CurOD->X.display,CurOD->X.window,
			  ButtonPressMask,&event))
   {
   *x = event.xbutton.x;
   *y = event.xbutton.y;
   *status = event.xbutton.button;
   return (1);
   }
 else
   return (0);
}     



int __XpgpX_Ink(unsigned short red,unsigned short green,unsigned short blue)
{
 XColor color;
 
 color.flags=DoRed|DoGreen|DoBlue;
 color.red=red;
 color.green=green;
 color.blue=blue;
 if(XAllocColor(CurOD->X.display,CurOD->X.colormap,&color)) {
     CurOD->X.NofInks++;
     if(CurOD->X.inks==NULL)
       CurOD->X.inks=
	 (unsigned long *)malloc(CurOD->X.NofInks*sizeof(unsigned long));
     else
       CurOD->X.inks=
	 (unsigned long *)realloc((void *)CurOD->X.inks,
				  CurOD->X.NofInks*sizeof(unsigned long));
     if(CurOD->X.inks==NULL) {
       fputs("Xpgp: not enough memory\n",stderr);
       return -1;
     }
     CurOD->X.inks[CurOD->X.NofInks-1]=color.pixel;
     return CurOD->X.NofInks-1;
 } else {
   fputs("Xpgp: color is not available\n",stderr);
   return -1;
 }
}


int __XpgpX_ClearPalette(void)
{
 XFreeColors(CurOD->X.display,CurOD->X.colormap,
	     CurOD->X.inks,CurOD->X.NofInks,0x0ul);
 CurOD->X.NofInks=0;
 free((void *)CurOD->X.inks);
 CurOD->X.inks=NULL;
 return 0;
}


int __XpgpX_ResetPalette(void)
{
 __XpgpX_ClearPalette();
 __XpgpX_AllocateBasicColors();
 __XpgpX_Pen(1);
 return 0;
}


int __XpgpX_SetBackground(int color)
{
 if(color>=CurOD->X.NofInks || color<0)
     return -1;
 XSetWindowBackground(CurOD->X.display,CurOD->X.window,
		      CurOD->X.inks[color]);
 XClearWindow(CurOD->X.display,CurOD->X.window);
 return 0;
}


int __XpgpX_Pen(int color)
{
 if(color>=CurOD->X.NofInks || color<0)
     return -1;
 XSetForeground(CurOD->X.display,CurOD->X.gc,CurOD->X.inks[color]);
 return 0;
 }



int __XpgpX_Paper(int color)
{
 if(color>=CurOD->X.NofInks || color<0)
     return -1;
 XSetBackground(CurOD->X.display,CurOD->X.gc,CurOD->X.inks[color]);
 return 0;
}


int __XpgpX_SetLineWidth(double w)
{
 XGCValues val;

 val.line_width=dtoi(w);
 XChangeGC(CurOD->X.display,CurOD->X.gc,GCLineWidth,&val);
 return 0;
}


int __XpgpX_SetDash(double b1, double w1, double b2, double w2)
{
 XGCValues val;
 char list[4];

 if(b1>0.0 && w1>0.0 && b2>0.0 && w2>0.0) {
     val.line_style=LineOnOffDash;
     if((list[0]=(char)dtoi(b1))==0) list[0]=1;
     if((list[1]=(char)dtoi(w1))==0) list[1]=1;
     if((list[2]=(char)dtoi(b2))==0) list[2]=1;
     if((list[3]=(char)dtoi(w2))==0) list[3]=1;
     XChangeGC(CurOD->X.display,CurOD->X.gc,GCLineStyle,&val);
     XSetDashes(CurOD->X.display,CurOD->X.gc,0,list,4);
 } else {
     val.line_style=LineSolid;
     XChangeGC(CurOD->X.display,CurOD->X.gc,GCLineStyle,&val);
 }   
 return 0;
}


int __XpgpX_SetFontSize(double size)
{
 XFontStruct *fnt_str;
 char font_name[256],d,n;
 int sizei;

 sizei=dtoi(size);
 for(n=1;n<32;n++) {
     d=((n&0x01)? -1:1)*(n>>1);
     sprintf(font_name,XPGP_XFONT,sizei+d);
     fnt_str=XLoadQueryFont(CurOD->X.display,font_name);
     if(fnt_str==NULL) {
	 if(!d)
	     fprintf(stderr,"Xpgp: can not load font: '%s'\n",font_name);
     } else {
	 XSetFont(CurOD->X.display,CurOD->X.gc,fnt_str->fid);
	 if(d)
	     fprintf(stderr,"Xpgp: using '%s' instead\n",font_name);
	 return 0;
     }
 }
 fprintf(stderr,"Xpgp: are you sure about %.3f point size\n",size);
 return -1;
}


int __XpgpX_Move(double x, double y)
{
 CurOD->X.gcur.x=x;
 CurOD->X.gcur.y=y;
 return 0;
}

int __XpgpX_MoveR(double dx, double dy)
{
 CurOD->X.gcur.x+=dx;
 CurOD->X.gcur.y+=dy;
 return 0;
}


int __XpgpX_Plot(double x, double y)
{
 CurOD->X.gcur.x=x;
 CurOD->X.gcur.y=y;
 XDrawPoint(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    dtoi(x),dtoi(y));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_PlotR(double dx, double dy)
{
 CurOD->X.gcur.x+=dx;
 CurOD->X.gcur.y+=dy;
 XDrawPoint(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fPlot(double x, double y)
{
 CurOD->X.gcur.x=x;
 CurOD->X.gcur.y=y;
 XDrawPoint(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    dtoi(x),dtoi(y));
 return 0;
}


int __XpgpX_fPlotR(double dx, double dy)
{
 CurOD->X.gcur.x+=dx;
 CurOD->X.gcur.y+=dy;
 XDrawPoint(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y));
 return 0;
}


int __XpgpX_Line(double x1, double y1, double x2, double y2)
{
 CurOD->X.gcur.x=x2;
 CurOD->X.gcur.y=y2;
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(x1),dtoi(y1),dtoi(x2),dtoi(y2));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_LineTo(double x, double y)
{
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y),dtoi(x),dtoi(y));
 CurOD->X.gcur.x=x;
 CurOD->X.gcur.y=y;
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_LineR(double dx, double dy)
{
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y),
	   dtoi(CurOD->X.gcur.x+dx),dtoi(CurOD->X.gcur.y+dy));
 CurOD->X.gcur.x+=dx;
 CurOD->X.gcur.y+=dy;
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fLine(double x1, double y1, double x2, double y2)
{
 CurOD->X.gcur.x=x2;
 CurOD->X.gcur.y=y2;
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(x1),dtoi(y1),dtoi(x2),dtoi(y2));
 return 0;
}


int __XpgpX_fLineTo(double x, double y)
{
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y),dtoi(x),dtoi(y));
 CurOD->X.gcur.x=x;
 CurOD->X.gcur.y=y;
 return 0;
}


int __XpgpX_fLineR(double dx, double dy)
{
 XDrawLine(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	   dtoi(CurOD->X.gcur.x),dtoi(CurOD->X.gcur.y),
	   dtoi(CurOD->X.gcur.x+dx),dtoi(CurOD->X.gcur.y+dy));
 CurOD->X.gcur.x+=dx;
 CurOD->X.gcur.y+=dy;
 return 0;
}


/*
 *  Triangle Functions
 */
int __XpgpX_Triangle(double x1, double y1,
		     double x2, double y2,
		     double x3, double y3)
{
 XPoint points[4];
 points[0].x=dtoi(x1);points[0].y=dtoi(y1);
 points[1].x=dtoi(x2);points[1].y=dtoi(y2);
 points[2].x=dtoi(x3);points[2].y=dtoi(y3);
 points[3].x=dtoi(x1);points[3].y=dtoi(y1);
 XDrawLines(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    points, 4, CoordModeOrigin);
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_FilledTriangle(double x1, double y1,
		     double x2, double y2,
		     double x3, double y3)
{
 XPoint points[4];
 points[0].x=dtoi(x1);points[0].y=dtoi(y1);
 points[1].x=dtoi(x2);points[1].y=dtoi(y2);
 points[2].x=dtoi(x3);points[2].y=dtoi(y3);
 points[3].x=dtoi(x1);points[3].y=dtoi(y1);
 XFillPolygon(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    points, 4, Convex, CoordModeOrigin);
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fTriangle(double x1, double y1,
		      double x2, double y2,
		      double x3, double y3)
{
 XPoint points[3];
 points[0].x=dtoi(x1);points[0].y=dtoi(y1);
 points[1].x=dtoi(x2);points[1].y=dtoi(y2);
 points[2].x=dtoi(x3);points[2].y=dtoi(y3);
 points[3].x=dtoi(x1);points[3].y=dtoi(y1);
 XDrawLines(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    points, 4, CoordModeOrigin);
 return 0;
}


int __XpgpX_Rectangle(double x, double y, double width, double height)
{
 XDrawRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x),dtoi(y),dtoi(width),dtoi(height));
 XFlush(CurOD->X.display);
 return 0;
}


/*
 *  Span rectangle
 */
int __XpgpX_RectangleS(double x1, double y1, double x2, double y2)
{
 XDrawRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x1),dtoi(y1),dtoi(x2-x1),dtoi(y2-y1));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_FilledRectangle(double x, double y, double width, double height)
{
 XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x),dtoi(y),dtoi(width),dtoi(height));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_FilledRectangleS(double x1, double y1, double x2, double y2)
{
 XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x1),dtoi(y1),dtoi(x2-x1),dtoi(y2-y1));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_Arc(double x, double y, double r1, double r2, double a1, double a2)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  dtoi(a1*64.0),dtoi((a2-a1)*64.0));
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_Circle(double x, double y, double r)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r),dtoi(y-r),
	  dtoi(2.0*r),dtoi(2.0*r),
	  0,360*64);
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_Ellipse(double x, double y, double r1, double r2)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  0,360*64);
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_FilledArc(double x, double y, double r1, double r2, double a1, double a2)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  dtoi(a1*64.0),dtoi((a2-a1)*64.0));
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_FilledCircle(double x, double y, double r)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r),dtoi(y-r),
	  dtoi(r*2.0),dtoi(r*2.0),
	  0,360*64);
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_FilledEllipse(double x, double y, double r1, double r2)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  0,360*64);
 XFlush(CurOD->X.display);
 return 0;
}
 

int __XpgpX_fFilledTriangle(double x1, double y1,
		     double x2, double y2,
		     double x3, double y3)
{
 XPoint points[4];
 points[0].x=dtoi(x1);points[0].y=dtoi(y1);
 points[1].x=dtoi(x2);points[1].y=dtoi(y2);
 points[2].x=dtoi(x3);points[2].y=dtoi(y3);
 points[3].x=dtoi(x1);points[3].y=dtoi(y1);
 XFillPolygon(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	    points, 4, Convex, CoordModeOrigin);
 return 0;
}


int __XpgpX_fRectangle(double x, double y, double width, double height)
{
 XDrawRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x),dtoi(y),dtoi(width),dtoi(height));
 return 0;
}


/*
 *  Span rectangle
 */
int __XpgpX_fRectangleS(double x1, double y1, double x2, double y2)
{
 XDrawRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x1),dtoi(y1),dtoi(x2-x1),dtoi(y2-y1));
 return 0;
}


int __XpgpX_fFilledRectangle(double x, double y, double width, double height)
{
 XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x),dtoi(y),dtoi(width),dtoi(height));
 return 0;
}


int __XpgpX_fFilledRectangleS(double x1, double y1, double x2, double y2)
{
 XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		dtoi(x1),dtoi(y1),dtoi(x2-x1),dtoi(y2-y1));
 return 0;
}


int __XpgpX_fArc(double x, double y, double r1, double r2, double a1, double a2)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  dtoi(a1*64.0),dtoi((a2-a1)*64.0));
 return 0;
}
 

int __XpgpX_fCircle(double x, double y, double r)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r),dtoi(y-r),
	  dtoi(r*2.0),dtoi(r*2.0),
	  0,360*64);
 return 0;
}
 

int __XpgpX_fEllipse(double x, double y, double r1, double r2)
{
 XDrawArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  0,360*64);
 return 0;
}
 

int __XpgpX_fFilledArc(double x, double y, double r1, double r2, double a1, double a2)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  dtoi(a1*64.0),dtoi((a2-a1)*64));
 return 0;
}
 

int __XpgpX_fFilledCircle(double x, double y, double r)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r),dtoi(y-r),
	  dtoi(r*2.0),dtoi(r*2.0),
	  0,360*64);
 return 0;
}
 

int __XpgpX_fFilledEllipse(double x, double y, double r1, double r2)
{
 XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	  dtoi(x-r1),dtoi(y-r2),
	  dtoi(r1*2.0),dtoi(r2*2.0),
	  0,360*64);
 return 0;
}
 

int __XpgpX_DrawString(double x, double y, char *text)
{
 XDrawString(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	     dtoi(x),dtoi(y),text,strlen(text));
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fDrawString(double x, double y, char *text)
{
 XDrawString(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	     dtoi(x),dtoi(y),text,strlen(text));
 return 0;
}


int __XpgpX_SetQP(double d, int shape)
{
 CurOD->X.QPd=d;
 CurOD->X.QPshape=shape;
 return 0;
}


int __XpgpX_PlotQP(double x, double y)
{
 int xi,yi;
 xi=dtoi(x);
 yi=dtoi(y);
 switch(CurOD->X.QPshape) {
   case 0:
     XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		    xi*CurOD->X.QPd,yi*CurOD->X.QPd,
		    CurOD->X.QPd,CurOD->X.QPd);
     break;
   case 1:
     XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	      xi*CurOD->X.QPd,yi*CurOD->X.QPd,
	      CurOD->X.QPd,CurOD->X.QPd,0,360*64);
     break;
   default:
     return -1;
 }
 XFlush(CurOD->X.display);
 return 0;
}


int __XpgpX_fPlotQP(double x, double y)
{
 int xi,yi;
 xi=dtoi(x);
 yi=dtoi(y);
 switch(CurOD->X.QPshape) {
   case 0:
     XFillRectangle(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
		    xi*CurOD->X.QPd,yi*CurOD->X.QPd,
		    CurOD->X.QPd,CurOD->X.QPd);
     break;
   case 1:
     XFillArc(CurOD->X.display,CurOD->X.window,CurOD->X.gc,
	      xi*CurOD->X.QPd,yi*CurOD->X.QPd,
	      CurOD->X.QPd,CurOD->X.QPd,0,360*64);
     break;
   default:
     return -1;
 }
 return 0;
}

int __XpgpX_PutImage(double x, double y, unsigned char *data,
                      unsigned int width,unsigned int height)
{
 XImage *image;
 char *Xdata;
 int screen;
 int bitmap_pad;
 long i;
 unsigned int depth;
 screen = XDefaultScreen(CurOD->X.display);
 depth = XDefaultDepth(CurOD->X.display,screen);
 if (depth == 8)
   {
   bitmap_pad = 8;
   /* allocate bitmap for color transformation */
   if ((Xdata = (char*)malloc(width*height*sizeof(char)))==NULL)
      {
      free(Xdata);
      printf("XPGP: Could not allocate memory in PutBitmap\n");
      return -1;
      }
   /* transform XPGP colors to X11 colors */
   for(i=0;i<width*height;i++)
      Xdata[i]=(char)CurOD->X.inks[data[i]];
   /* create XImage structure */
   image = XCreateImage(CurOD->X.display,DefaultVisual(CurOD->X.display,screen),
           depth,ZPixmap,0,Xdata,width,height,bitmap_pad,0);
   /* put XImage Structure */
   XPutImage(CurOD->X.display,CurOD->X.window,CurOD->X.gc,image,0,0,(int)x,
             (int)y,width,height);
   /* free XImage structure */ 
   free(Xdata);
   XFree(image);
   /*free transformed Bitmap */
   return 0;
   }
else 
   {
   printf("Only 8 Bit Bitmaps supported\n");
   return -1;
   }
}

int __XpgpX_PutBitmap(double x, double y, char *bitmap,
                      unsigned int width,unsigned int height,int fg,int bg)
{
 Pixmap pixmap;
 XGCValues values;
 GC tempGC;
 int rv;
 unsigned int w,h;
 int xhot,yhot;
 
 if (width == 0 || height == 0)
 /* read X11 Bitmap from File */
 
    {rv=XReadBitmapFile(CurOD->X.display,CurOD->X.window,
		 bitmap, &w,&h,&pixmap,&xhot,&yhot);
   switch(rv) {
   case BitmapOpenFailed:
     fputs("Xpgp(PutBitmap): bitmap file open failed\n",stderr);
     break;
   case BitmapFileInvalid:
     fputs("Xpgp(PutBitmap): bitmap file invalid\n",stderr);
     break;  
   case BitmapNoMemory:
     fputs("Xpgp(PutBitmap): not enough memory for bitmap\n",stderr);
     break;
     }
   values.foreground=CurOD->X.inks[fg];
   values.background=CurOD->X.inks[bg];
   tempGC = XCreateGC(CurOD->X.display,CurOD->X.window,GCForeground | GCBackground,
             &values);
   XCopyPlane( CurOD->X.display,pixmap,CurOD->X.window,tempGC,0,0,w,h,
              (int)x,(int)y,1);                
   XFreeGC(CurOD->X.display,tempGC);
   }
 else
   {
    pixmap = XCreatePixmapFromBitmapData(CurOD->X.display,CurOD->X.window,
          bitmap,width,height,CurOD->X.inks[fg],CurOD->X.inks[bg],8);

    XCopyArea(CurOD->X.display,pixmap,CurOD->X.window,CurOD->X.gc,0,0,
              width,height,(int)x,(int)y);
    }        

 XFreePixmap(CurOD->X.display,pixmap);
 return 0;
}

/*****************************************************************************

                          P R I V A T E

 *****************************************************************************/

int __XpgpX_AllocateBasicColors(void)
{
 static char *color_names[]={
    "White","Black",
    "Light Blue","Cyan","Blue","Navy","Violet",
    "Magenta","Purple","Pink","Khaki","Aquamarine",
    "Pale Green","Green","Lime Green","Yellow Green","Green Yellow","Yellow",
    "Gold","Light Goldenrod","Goldenrod","Dark Goldenrod",
    "Brown","Chocolate","Peru","Coral",
    "Light Coral","Salmon",
    "Dark Orange","Orange","Orange Red",
    "Red",
    ""};
 int i;
 XColor scr,exa;

 for(i=0;*color_names[i];i++)
     if(XAllocNamedColor(CurOD->X.display,CurOD->X.colormap,
			 color_names[i],&scr,&exa)) {
	 CurOD->X.NofInks++;
	 if(CurOD->X.inks!=NULL)
	     CurOD->X.inks=(unsigned long *)realloc((void *)CurOD->X.inks,
						      CurOD->X.NofInks*
						      sizeof(unsigned long));
	 else
	     CurOD->X.inks=(unsigned long *)malloc(CurOD->X.NofInks*
						     sizeof(unsigned long));
	 CurOD->X.inks[CurOD->X.NofInks-1]=scr.pixel;
	 if(CurOD->X.inks==NULL) {
	   fputs("Xpgp: not enough memory\n",stderr);
	   return -1;
	 }
     } else {
       fputs("Xpgp: basic colors are not available\n",stderr);
       return -1;
     }
 return 0;
}

