/*****************************************************************************
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
/*                                                                           */
/*                                   #                                       */
/*                                   #                                       */
/*                                  ###                                      */
/*                                  ###                                      */
/*                                 #####                                     */
/*                                 #####                                     */
/*                                #######                                    */
/*                                #######                                    */
/*                   #################################                       */
/*                       #########################                           */
/*                           #################                               */
/*                  [[[[The Working Class Unlimited]]]                       */
/*                             #############                                 */
/*                             #############                                 */
/*                            ######   ######                                */
/*                            ###         ####                               */
/*                           ##              ##                              */
/*                          #                  #                             */
/*                                                                           */
/*                 (C) The Working Class Unlimited 1994.                     */

/**
 **
 **			  X p g p  d e m o - 1 (v2.24)
 **
 **
 **   There is no software like public domain software.
 **
 **/
#include <stdio.h>
#include <stdlib.h>
#include "Xpgp.h"
#include "digital_logo.bm"

int main ()
{
 int i,j,x,y;
 unsigned int status;
 double d;
 int color,color1,color2;
 char str[64];
 unsigned char testimg[20000];
 
 fputs("\n  Xpgp Demo\n\n",stdout);

 fputs("Initialization ...\n",stdout);

 
 i=OpenX(600,600);		/* initialization */
 printf("Device %d initialized\n",i);
 i=OpenXX(300,300, 50,50, "Xpgp demo1","Xpgp", "Xpgp.xbm", NULL);
 printf("Device %d initialized\n",i);

 Pen(31);
 Line(0,0,300,300);
 Pen(14);
 Line(0,300,300,0);
 
 fputs("<return>",stdout);
 fgetc(stdin);

 SetFocus(1);
 OutputTo(1);
 while (GetMousePressEvent(&x,&y,&status)==1)
   printf("Mouseclick at %d,%d key %ud\n",x,y,status);
 fgetc(stdin);

 SetFocus(0);
 OutputTo(0);

 Pen(1);			/* primitives */
 Plot(100,100);
 Plot(101,101);
 PlotR(10,10);
 Line(20,20,90,90);
 LineTo(90,400);
 LineR(100,-100);
 Rectangle(102,102,20,20);
 RectangleS(200,200,220,210);
 Circle(400,200,40);
 Ellipse(400,200,80,40);
 Arc(400,200,160,80,45,270);
 Pen(5);
 SetQP(30,QPrect);
 PlotQP(8,15);
 PlotQP(7,16);

 
 fputs("<return>",stdout);
 fgetc(stdin);

 Pen(31);
 fPlot(100,100);
 fPlot(101,101);
 fPlotR(10,10);
 fLine(20,20,90,90);
 fLineTo(90,400);
 fLineR(100,-100);
 fRectangle(102,102,20,20);
 fRectangleS(200,200,220,210);
 fCircle(400,200,40);
 fEllipse(400,200,80,40);
 fArc(400,200,160,80,45,270);
 Pen(20);
 SetQP(30,QPcirc);
 fPlotQP(5,16);
 fPlotQP(5,17);
 fPlotQP(6,17);
 fShow();

 fputs("<return>",stdout);
 fgetc(stdin);

 
 Clear();
 Pen(1);
 DrawString(20,50,"Line Width & Dash");
 for(d=10.0;d>=0.0;d-=0.25) {
   SetDash((double)rand()*10/RAND_MAX,(double)rand()*10/RAND_MAX,
	   (double)rand()*10/RAND_MAX,(double)rand()*10/RAND_MAX);
   SetLineWidth(d);
   Line(d*50+50,100,d*50+50,500);
 }
 SetDash(0.0,0.0,0.0,0.0);

 fputs("<return>",stdout);
 fgetc(stdin);

 
 Clear();
 Pen(1);
 DrawString(20,80,"Triangles");
 Triangle(100,100,200,200,100,200);
 FilledTriangle(300,300,400,400,400,500);
 fTriangle(10,10,20,20,10,20);
 fFilledTriangle(30,30,40,40,40,50);
 for(i=0;i<10;i++)
   fTriangle((double)rand()*600/RAND_MAX,(double)rand()*600/RAND_MAX,
	     (double)rand()*600/RAND_MAX,(double)rand()*600/RAND_MAX,
	     (double)rand()*600/RAND_MAX,(double)rand()*600/RAND_MAX);
 fShow();
 fputs("<return>",stdout);
 fgetc(stdin);

 
 Clear();
 Pen(1);
 i=0;
 while(!Pen(i++)) {
     fFilledEllipse(i*15,300,7,200);
     Pen(1);
     fEllipse(i*15,300,7,200);
 }

 i=0;
 while(!Pen(i++)) {
     sprintf(str,"%2d",i-1);
     fDrawString(i*15-4,520,str);
 }
 fShow();
 SetFontSize(18);
 DrawString(20,50,"Spectrum");
 
 fputs("<return>",stdout);
 fgetc(stdin);

 
 
 Clear();
 Pen(1);

 DrawString(20,50,"Palette");
 for(i=0;i<40;i++)
  for(j=0;j<250;j++) testimg[i*250+j]=(char)j;
 PutImage(50.,50.,testimg,250,40);
 PutImage(80.,150.,testimg,250,40);
 PutImage(120.,70.,testimg,250,40);
 PutBitmap(0.,30.,digital_logo_bits,digital_logo_width,digital_logo_height,
           0,31);
 PutBitmap(80.,50.,digital_logo_bits,digital_logo_width,digital_logo_height,
           0,31);
 PutBitmap(160.,70.,digital_logo_bits,digital_logo_width,digital_logo_height,
           0,31);
 PutBitmap(120.,120.,"cec_logo_1.bm",0,0,1,0);
fShow();

 ClearPalette();

 for(i=0;i<=600 && (color=Ink((655-i)*100,0,0))>=0;i+=2) {
     Pen(color);
     fLine(i,220,300,580);
     fLine(i+1,220,300,580);
 }
 fShow();

 fputs("<return>",stdout);
 fgetc(stdin);
 Clear();
 DrawString(20,50,"Images");

 for(i=0;i<40;i++)
  for(j=0;j<250;j++) testimg[i*250+j]=(char)j;
 PutImage(50.,50.,testimg,250,40);
 PutImage(80.,150.,testimg,250,40);
 PutImage(120.,70.,testimg,250,40);
 fShow();
 
 fputs("<return>",stdout);
 fgetc(stdin);

 DrawString(20,100,"Reset palette");
 ResetPalette();
 i=0;
 while(!Pen(i++)) {
     fFilledCircle(i*10,550,5);
     Pen(1);
     fCircle(i*10,550,5);
 }
 fShow();
     
 fputs("<return>",stdout);
 fgetc(stdin);

 Clear();    
 Pen(4);
 for(i=0;i<600;i+=5) {
     fLine(0,i,600-i,0);
     fEllipse(300,300,i/2,i/3);
 }
 fShow();
 
 fputs("<return>",stdout);
 fgetc(stdin);

 Clear();
 Pen(1);
 DrawString(20,50,"Quasi Pixel concept");
 SetQP(10,QPrect);
 Pen(31);
 for(i=0;i<500;i++)
   fPlotQP((double)rand()*60/RAND_MAX,
	   (double)rand()*60/RAND_MAX);
 SetQP(10,QPcirc);
 Pen(4);
 for(i=0;i<600;i++) {
   fPlotQP((double)rand()*60/RAND_MAX,
	   (double)rand()*60/RAND_MAX);
 }
 fShow();

 fputs("<return>",stdout);
 fgetc(stdin);

 Clear();
 Pen(8);
 Move(300,300);
 for(i=0;i<200;i+=10)
     fRectangle(300-i,300-i/2,i*2,i);
 fShow();

 fputs("<return>",stdout);
 fgetc(stdin);

 Clear();
 Pen(14);
 Move(300,300);
 for(i=0;i<200;i++)
   fLineR((double)rand()*40/RAND_MAX-20,
	  (double)rand()*40/RAND_MAX-20);
 fShow();

 Pen(11);
 for(i=0;i<300;i+=5)
     fArc(300,300,i,i/2,0,i);
 fShow();

 fputs("<return>",stdout);
 fgetc(stdin);

 Clear();
 ClearPalette();
 color1 = Ink(0xa000,0xa000,0xa000);
 color2 = Ink(0,0xffff,0);
 SetBackground(color1);
 Pen(color2);
 DrawString(460,540,"The End!");
 
 fputs("The End!",stdout);
 fgetc(stdin);

 return 0;
}
